package fi.er.opplugin;

import com.alibaba.druid.util.StringUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.property.BasedataProp;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.MulBasedataEdit;
import kd.bos.form.field.RefBillEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Date;
import java.util.EventObject;

public class FinapbillBeforeF7SelectSample extends AbstractFormPlugin implements BeforeF7SelectListener {
    private static String nckd_apfinapbill = "nckd_apfinapbill"; //应付挂账单字段
    private static String nckd_real_card = "assetentry.nckd_real_card"; //应付挂账单字段
    private static String nckd_ap_finapbill_gz = "ap_finapbill"; //应付挂账单标识
    private static String nckd_er_publicreimbur_ext = "er_publicreimbursebill"; //报销单标识
    @Override
    public void registerListener(EventObject e) {
        //监听单据字段
        super.registerListener(e);
        RefBillEdit bill = this.getView().getControl(nckd_apfinapbill);
        MulBasedataEdit mEdit = this.getView().getControl("nckd_real_card");
        mEdit.addBeforeF7SelectListener(this);
        bill.addBeforeF7SelectListener(this);
    }
    @Override
    public void beforeF7Select(BeforeF7SelectEvent arg0) {
        String fieldKey = arg0.getProperty().getName();
        if (StringUtils.equals(fieldKey, nckd_apfinapbill)){
            // 生成过滤条件对象QFilter
            Object nckd_sourcebillid = this.getModel().getValue("nckd_sourcebillid");
            if (nckd_sourcebillid != null) {
                //查询暂估报销单
                String sourcebillid = String.valueOf(nckd_sourcebillid);
                QFilter filter = new QFilter("nckd_sourcebillid", QCP.equals,sourcebillid);
                filter.and("nckd_ywlx", QCP.equals, "2");
                DynamicObject[] bxDynamicObjects = BusinessDataServiceHelper.load(nckd_er_publicreimbur_ext,"id",new QFilter[] {filter});
                if (bxDynamicObjects.length > 0) {
                    DynamicObject bxInfo = BusinessDataServiceHelper.loadSingle(bxDynamicObjects[0].getPkValue(), bxDynamicObjects[0].getDynamicObjectType().getName());
                    Long id = bxInfo.getLong("id");
                    QFilter qFilter = new QFilter("sourcebillid", QCP.equals,id);
                    // 表过滤条件
                    ListShowParameter showParameter = (ListShowParameter)arg0.getFormShowParameter();
                    showParameter.getListFilterParameter().setFilter(qFilter);
                }
            }else {
                //选取不到应付挂账单
                QFilter qFilter = new QFilter("id", QCP.equals,null);
                // 表过滤条件
                ListShowParameter showParameter = (ListShowParameter)arg0.getFormShowParameter();
                showParameter.getListFilterParameter().setFilter(qFilter);
            }
        } else if (StringUtils.equals(fieldKey, "nckd_real_card")) {
            DynamicObject assetorg = (DynamicObject) this.getModel().getValue("assetorg");//资产组织
            QFilter qFilter = new QFilter("nckd_orgfield.id", QCP.equals, assetorg.getLong("id"));
            // 表过滤条件
            ListShowParameter showParameter = (ListShowParameter)arg0.getFormShowParameter();
            showParameter.setShowApproved(false);
            showParameter.getListFilterParameter().setFilter(qFilter);
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        String fieldKey = e.getProperty().getName();
        if (StringUtils.equals("nckd_real_card", fieldKey)){
            ChangeData changeData = e.getChangeSet()[0];
            DynamicObjectCollection dynamicObjectCollection = (DynamicObjectCollection) changeData.getNewValue();
            int parentIndex = changeData.getRowIndex();
            this.getModel().deleteEntryData("nckd_realcard_list2");
            for (int i = 0; i < dynamicObjectCollection.size(); i++) {
                DynamicObject object = dynamicObjectCollection.get(i);
                this.getModel().setValue("nckd_card_list_str","1");
                //实物卡片清单分录赋值
                DynamicObject cardInfo = BusinessDataServiceHelper.loadSingle(object.get(2), "nckd_fa_card_real_list");
                int rowIndex = this.getModel().createNewEntryRow("nckd_realcard_list2");
                this.getModel().setValue("nckd_card_code2",cardInfo,rowIndex,parentIndex);
                if (i == 0) {
                    String name = cardInfo.getString("name");//资产名称
                    DynamicObject nckd_dept = cardInfo.getDynamicObject("nckd_dept");//归属部门
                    String nckd_use_name = cardInfo.getString("nckd_use_name");//使用人
                    String nckd_local = cardInfo.getString("nckd_local");//存放地点
                    String nckd_card_model = cardInfo.getString("nckd_card_model");//型号
                    Date nckd_start_date = cardInfo.getDate("nckd_start_date");//开始使用日期
                    //资产信息分录赋值
                    this.getModel().setValue("asset_name", name, parentIndex);
                    //资产发生日期
                    this.getModel().setValue("asset_happendate", nckd_start_date, parentIndex);
                    //规格型号
                    this.getModel().setValue("asset_model",nckd_card_model, parentIndex);
                    //使用部门
                    this.getModel().setValue("asset_costdept",nckd_dept, parentIndex);
                    //使用人
                    QFilter userFilter = new QFilter("number", QCP.equals,nckd_use_name);
                    DynamicObject[] userDynamicObjects = BusinessDataServiceHelper.load("bos_user","id",new QFilter[] {userFilter});
                    for (int d=0;d<userDynamicObjects.length;d++) {
                        DynamicObject userInfo = BusinessDataServiceHelper.loadSingle(userDynamicObjects[i].getPkValue(), userDynamicObjects[i].getDynamicObjectType().getName());
                        this.getModel().setValue("asset_user",userInfo, parentIndex);
                    }
                    //存放地点
                    this.getModel().setValue("nckd_storeplace",nckd_local, parentIndex);
                }
            }
            //刷新实物卡片清单分录
            this.getView().updateView("assetentry");
        } else if (StringUtils.equals("nckd_apfinapbill", fieldKey)) {
            ChangeData changeData = e.getChangeSet()[0];
            DynamicObject dynamicObject = (DynamicObject) changeData.getNewValue();
            if (dynamicObject != null) {
                Long id = dynamicObject.getLong("id");
                //查询应付挂账
                QFilter filter = new QFilter("id", QCP.equals,id);
                DynamicObject[] yfgzDynamicObjects = BusinessDataServiceHelper.load(nckd_ap_finapbill_gz,"id",new QFilter[] {filter});
                DynamicObject gzInfo = BusinessDataServiceHelper.loadSingle(yfgzDynamicObjects[0].getPkValue(), yfgzDynamicObjects[0].getDynamicObjectType().getName());
                String billno = gzInfo.getString("billno");//单据编号
                DynamicObject org = gzInfo.getDynamicObject("org");//结算组织
                DynamicObject detailentry = gzInfo.getDynamicObjectCollection("detailentry").get(0);
                DynamicObject expenseitem = detailentry.getDynamicObject("expenseitem");//费用项目
                DynamicObject receivingsupplierid = gzInfo.getDynamicObject("receivingsupplierid");//供应商
                Date bookdate = gzInfo.getDate("bookdate");
                String remark = gzInfo.getString("remark");
                BigDecimal pricetaxtotal = gzInfo.getBigDecimal("pricetaxtotal");//应付金额
                BigDecimal e_amount = BigDecimal.ZERO;//不含税应付金额
                BigDecimal expenseamount = BigDecimal.ZERO;//报销金额
                BigDecimal orientryamount = BigDecimal.ZERO;//不含税金额

                //应付挂账单明细分录
                DynamicObjectCollection detailentry1 = gzInfo.getDynamicObjectCollection("detailentry");
                for (DynamicObject object : detailentry1) {
                    e_amount = e_amount.add(object.getBigDecimal("e_amount"));
                }

                //费用明细分录
                DynamicObjectCollection expenseentryentity = this.getModel().getEntryEntity("expenseentryentity");
                for (DynamicObject object : expenseentryentity) {
                    expenseamount = expenseamount.add(object.getBigDecimal("expenseamount"));
                    orientryamount = orientryamount.add(object.getBigDecimal("orientryamount"));
                }

                //冲销金额
                BigDecimal nckd_accloanamount = expenseamount;

                //不含税借款余额
                BigDecimal nckd_e_amount = e_amount;

                //不含税冲销金额
                BigDecimal nckd_amountfield6 = orientryamount;

                //差额
                BigDecimal nckd_sub_amount = pricetaxtotal.subtract(nckd_accloanamount);

                //不含税差额
                BigDecimal nckd_amountfield8 = nckd_e_amount.subtract(nckd_amountfield6);

                //给冲预付借款赋值
                this.getModel().deleteEntryData("nckd_ap_finapbill_detail");
                int rowIndex = this.getModel().createNewEntryRow("nckd_ap_finapbill_detail");

                this.getModel().setValue("nckd_loanbillnov1",billno,rowIndex);
                this.getModel().setValue("nckd_sourceentrycostdept",org,rowIndex);
                this.getModel().setValue("nckd_sourceentrycostcompa",org,rowIndex);
                this.getModel().setValue("nckd_sourceexpenseitem",expenseitem,rowIndex);
//                this.getModel().setValue("nckd_srcentrywlunit",receivingsupplierid,rowIndex);
                this.getModel().setValue("nckd_loanapplydatev1",bookdate,rowIndex);
                this.getModel().setValue("nckd_loandescriptionv1",remark,rowIndex);
                this.getModel().setValue("nckd_loanamount",pricetaxtotal,rowIndex);
                this.getModel().setValue("nckd_currloanamount",pricetaxtotal,rowIndex);
                this.getModel().setValue("nckd_accloanamount",nckd_accloanamount,rowIndex);
                this.getModel().setValue("nckd_curraccloanamount",nckd_accloanamount,rowIndex);
                this.getModel().setValue("nckd_amountfield7",nckd_sub_amount,rowIndex);
                this.getModel().setValue("nckd_e_amount",nckd_e_amount,rowIndex);
                this.getModel().setValue("nckd_amountfield6",nckd_amountfield6,rowIndex);
                this.getModel().setValue("nckd_amountfield8",nckd_amountfield8,rowIndex);

                DynamicObjectCollection assetentry = this.getModel().getEntryEntity("assetentry");
                if(assetentry.size() > 0) {
                    this.getModel().setValue("nckd_amountfield9",nckd_sub_amount,0);
                    this.getModel().setValue("nckd_amountfield10",nckd_amountfield8,0);
                }

                //刷新冲预付借款分录
                this.getView().updateView("nckd_ap_finapbill_detail");
                this.getView().updateView("assetentry");
            }
        }else if (StringUtils.equals("expenseamount", fieldKey) || StringUtils.equals("nckd_amountfield3", fieldKey)) {
            String reimbursetype = (String) this.getModel().getValue("reimbursetype");
            if("asset".equals(reimbursetype)) {
                if (this.getModel().getEntryEntity("assetentry").size() == 0) {
                    int rowIndex = this.getModel().createNewEntryRow("assetentry");
                }
                ChangeData changeData = e.getChangeSet()[0];
                BigDecimal expenseamount = (BigDecimal) changeData.getNewValue();
                this.getModel().setValue("nckd_amountfield3", expenseamount, 0);//含税单价

                //含税金额 = 含税单价*数量
                BigDecimal asset_quantity = (BigDecimal) this.getModel().getValue("asset_quantity");
                BigDecimal assetexpenseamount = expenseamount.multiply(asset_quantity);
                this.getModel().setValue("assetexpenseamount", assetexpenseamount, 0);

                //不含税单价 = 含税单价/(1+税率)
                BigDecimal assettaxrate = (BigDecimal) this.getModel().getValue("assettaxrate");
                assettaxrate = assettaxrate.divide(new BigDecimal(100), 2, RoundingMode.HALF_UP);
                BigDecimal rate = assettaxrate.add(BigDecimal.ONE);
                BigDecimal assetpricewithouttax = expenseamount.divide(rate, 2 , RoundingMode.HALF_UP);
                this.getModel().setValue("assetpricewithouttax", assetpricewithouttax, 0);

                //不含税金额 = 不含税单价*数量
                BigDecimal assetorientryamount = assetpricewithouttax.multiply(asset_quantity);
                this.getModel().setValue("assetorientryamount", assetorientryamount, 0);

                //税额 = 含税金额-不含税金额
                BigDecimal assettaxamount = assetexpenseamount.subtract(assetorientryamount);
                this.getModel().setValue("assettaxamount", assettaxamount, 0);
            }

            DynamicObjectCollection nckd_ap_finapbill_detail = this.getModel().getEntryEntity("nckd_ap_finapbill_detail");
            if (nckd_ap_finapbill_detail.size() > 0) {
                BigDecimal expenseamount = BigDecimal.ZERO;//核定金额
                BigDecimal orientryamount = BigDecimal.ZERO;//不含税核定金额
                //费用明细分录
                DynamicObjectCollection expenseentryentity = this.getModel().getEntryEntity("expenseentryentity");
                for (DynamicObject object : expenseentryentity) {
                    expenseamount = expenseamount.add(object.getBigDecimal("expenseamount"));
                    orientryamount = orientryamount.add(object.getBigDecimal("orientryamount"));
                }

                //冲销金额
                BigDecimal nckd_accloanamount = expenseamount;
                //不含税冲销金额
                BigDecimal nckd_amountfield6 = orientryamount;
                //借款余额
                BigDecimal nckd_loanamount = nckd_ap_finapbill_detail.get(0).getBigDecimal("nckd_loanamount");
                //不含税借款余额
                BigDecimal nckd_e_amount = nckd_ap_finapbill_detail.get(0).getBigDecimal("nckd_e_amount");
                //差额
                BigDecimal nckd_sub_amount = nckd_loanamount.subtract(nckd_accloanamount);
                //不含税差额
                BigDecimal nckd_amountfield8 = nckd_e_amount.subtract(nckd_amountfield6);

                this.getModel().setValue("nckd_loanamount",nckd_loanamount,0);
                this.getModel().setValue("nckd_currloanamount",nckd_loanamount,0);
                this.getModel().setValue("nckd_accloanamount",nckd_accloanamount,0);
                this.getModel().setValue("nckd_curraccloanamount",nckd_accloanamount,0);
                this.getModel().setValue("nckd_amountfield7",nckd_sub_amount,0);
                this.getModel().setValue("nckd_e_amount",nckd_e_amount,0);
                this.getModel().setValue("nckd_amountfield6",nckd_amountfield6,0);
                this.getModel().setValue("nckd_amountfield8",nckd_amountfield8,0);

                DynamicObjectCollection assetentry = this.getModel().getEntryEntity("assetentry");
                if(assetentry.size() > 0) {
                    this.getModel().setValue("nckd_amountfield9",nckd_sub_amount,0);
                    this.getModel().setValue("nckd_amountfield10",nckd_amountfield8,0);
                }

                //刷新冲预付借款分录
                this.getView().updateView("nckd_ap_finapbill_detail");
                this.getView().updateView("assetentry");
            }
        } else if (StringUtils.equals("taxrate", fieldKey) || StringUtils.equals("assettaxrate", fieldKey)) {
            String reimbursetype = (String) this.getModel().getValue("reimbursetype");
            if("asset".equals(reimbursetype)) {
                if (this.getModel().getEntryEntity("assetentry").size() == 0) {
                    int rowIndex = this.getModel().createNewEntryRow("assetentry");
                }
                ChangeData changeData = e.getChangeSet()[0];
                BigDecimal assettaxrate = (BigDecimal) changeData.getNewValue();
                this.getModel().setValue("assettaxrate", assettaxrate,0);//税率

                //含税金额 = 含税单价 * 数量
                BigDecimal nckd_amountfield3 = (BigDecimal) this.getModel().getValue("nckd_amountfield3");
                BigDecimal asset_quantity = (BigDecimal) this.getModel().getValue("asset_quantity");
                BigDecimal assetexpenseamount = nckd_amountfield3.multiply(asset_quantity);
                this.getModel().setValue("assetexpenseamount", assetexpenseamount,0);

                //不含税单价 = 含税单价/(1+税率)
                assettaxrate = assettaxrate.divide(new BigDecimal(100), 2, RoundingMode.HALF_UP);
                BigDecimal rate = assettaxrate.add(BigDecimal.ONE);
                BigDecimal assetpricewithouttax = nckd_amountfield3.divide(rate, 2 , RoundingMode.HALF_UP);
                this.getModel().setValue("assetpricewithouttax", assetpricewithouttax,0);

                //不含税金额 = 不含税单价*数量
                BigDecimal assetorientryamount = assetpricewithouttax.multiply(asset_quantity);
                this.getModel().setValue("assetorientryamount", assetorientryamount,0);

                //税额 = 含税金额-不含税金额
                BigDecimal assettaxamount = assetexpenseamount.subtract(assetorientryamount);
                this.getModel().setValue("assettaxamount", assettaxamount, 0);
            }

            DynamicObjectCollection nckd_ap_finapbill_detail = this.getModel().getEntryEntity("nckd_ap_finapbill_detail");
            if (nckd_ap_finapbill_detail.size() > 0) {
                BigDecimal orientryamount = BigDecimal.ZERO;//不含税核定金额
                //费用明细分录
                DynamicObjectCollection expenseentryentity = this.getModel().getEntryEntity("expenseentryentity");
                for (DynamicObject object : expenseentryentity) {
                    orientryamount = orientryamount.add(object.getBigDecimal("orientryamount"));
                }

                //不含税冲销金额
                BigDecimal nckd_amountfield6 = orientryamount;
                //不含税借款余额
                BigDecimal nckd_e_amount = nckd_ap_finapbill_detail.get(0).getBigDecimal("nckd_e_amount");
                //不含税差额
                BigDecimal nckd_amountfield8 = nckd_e_amount.subtract(nckd_amountfield6);

                this.getModel().setValue("nckd_e_amount",nckd_e_amount,0);
                this.getModel().setValue("nckd_amountfield6",nckd_amountfield6,0);
                this.getModel().setValue("nckd_amountfield8",nckd_amountfield8,0);

                DynamicObjectCollection assetentry = this.getModel().getEntryEntity("assetentry");
                if(assetentry.size() > 0) {
                    this.getModel().setValue("nckd_amountfield10",nckd_amountfield8,0);
                }

                //刷新冲预付借款分录
                this.getView().updateView("nckd_ap_finapbill_detail");
                this.getView().updateView("assetentry");
            }
        }else if (StringUtils.equals("isbeforeshare", fieldKey)) {
            ChangeData changeData = e.getChangeSet()[0];
            Boolean isbeforeshare = (Boolean) changeData.getNewValue();
            if (isbeforeshare) {
                BasedataEdit basedataEdit = this.getControl("entrycostdept_orgrule");
                basedataEdit.setMustInput(false);
                BasedataProp basedataProp = (BasedataProp) basedataEdit.getProperty();
                basedataProp.setMustInput(false);
            }
        }else if (StringUtils.equals("sharerate_comrule", fieldKey)) {
            ChangeData changeData = e.getChangeSet()[0];
            BigDecimal sharerate_comrule = (BigDecimal) changeData.getNewValue();
            sharerate_comrule = sharerate_comrule.divide(BigDecimal.valueOf(100));
            BigDecimal reimburseamount = (BigDecimal) this.getModel().getValue("reimburseamount");
            BigDecimal ftAmount = reimburseamount.multiply(sharerate_comrule);
            this.getModel().setValue("nckd_ft_amount", ftAmount);
        }else if (StringUtils.equals("sharemethod", fieldKey)) {
            ChangeData changeData = e.getChangeSet()[0];
            String sharemethod = (String) changeData.getNewValue();
            DynamicObjectCollection expenseentryentity_rules = this.getModel().getEntryEntity("expenseentryentity_rule");
            if (expenseentryentity_rules.size() > 0) {
                if (StringUtils.equals(sharemethod, "rate")) {
                    for (int i = 0; i < expenseentryentity_rules.size(); i++) {
                        this.getModel().setValue("nckd_ft_amount", null, i);
                    }
                } else if (StringUtils.equals(sharemethod, "avg")) {
                    BigDecimal reimburseamount = (BigDecimal) this.getModel().getValue("reimburseamount");
                    BigDecimal nckd_ft_amount = reimburseamount.divide(BigDecimal.valueOf(expenseentryentity_rules.size()));
                    for (int i = 0; i < expenseentryentity_rules.size(); i++) {
                        this.getModel().setValue("nckd_ft_amount", nckd_ft_amount, i);
                    }
                }
            }
        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        //报账类型
        String reimbursetype = (String) this.getModel().getValue("reimbursetype");
        int rowIndex = this.getModel().createNewEntryRow("assetentry");
        if("asset".equals(reimbursetype)){
            //给资产信息分录，核算组织，使用部门赋值
            DynamicObject assetorg = (DynamicObject) this.getModel().getValue("assetorg");//资产组织
            DynamicObject costdept = (DynamicObject) this.getModel().getValue("costdept");//费用承担部门
            this.getModel().setValue("nckd_orgfield1", assetorg.getLong("id"), 0);//核算组织
            this.getModel().setValue("asset_costdept", costdept.getLong("id"), 0);//使用部门
        }
    }

}
